
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>初探SQL Server CLR 集成 / iVAN</title>

    <meta name="description" content="初探SQL Server CLR 集成 sqlserver 2005中,加入了很多新特性.对于开发人员来讲,最值得一提的是对XML的支持和CLR集成.当然,还有一些关于&quot;高可用&quot;(数据库集群/数据库镜像/日志传送等)的新特性,比较适合DBA,感兴趣的朋友可以了解一下. 相信很多人和我一样,一直很希望在sqlserver中非常灵活地编程,实现各种功能(能像在VS中使用C#编程一样的爽).但是未能如愿,暂不说开发环境的问题(代码补全,配色等).最主要的是,T-SQL这东西确实不适合做复杂的运算(对我这种菜鸟来讲确实有难 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">初探SQL Server CLR 集成</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>sqlserver<br />
 2005中，加入了很多新特性。对于开发人员来讲，最值得一提的是对XML的支持和CLR集成。当然，还有一些关于“高可用“（数据库集群/数据库镜像/日志传送等）的新特性，比较适合DBA，感兴趣的朋友可以了解一下。</p>
<p>相信很多人和我一样，一直很希望在sqlserver中非常灵活地编程，实现各种功能（能像在VS中使用C#编程一样的爽）。但是未能如愿，暂不说开发环境的问题（代码补全，配色等）。最主要的是，T-SQL这东西确实不适合做复杂的运算（对我这种菜鸟来讲确实有难度。对那些大牛来说估计不难），也缺乏面向对象编程的灵活性。连一些基本的数据结构也没有办法实现，更别提什么面向对象了。</p>
<p>有了sqlserver<br />
 CLR集成后，这一切似乎就变了。什么是CLR ，到底什么是CLR集成？先看看MSDN的解释吧。</p>
<p>通过在 Microsoft SQL Server 中托管 CLR（称为 CLR 集成），可以在托管代码中编写存储过程、触发器、用户定义函数、用户定义类型和用户定义聚合函数。 因为托管代码在执行之前会编译为本机代码，所以，在有些方案中可以大大提高性能。</p>
<p>通俗点讲，就是sqlserver 2005 版本之后，数据库引擎中加入了 .NET Framework 的公共语言运行时 (CLR) 组件，可以更方便和.NET应用程序交互。</p>
<p>首先，新建一个sqlserver<br />
 CLR 数据库项目，如图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDEyMDMvMTkvMF8xMzMyMTQxODUzOVFNcS5naWY=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDEyMDMvMTkvMF8xMzMyMTQxODg0MjYyMi5naWY=.jpg"></p>
<p>项目新建好之后，可以打开试图，看看结构，里面只包含一些测试示例的sql脚本。</p>
<p>接下来，新建一个普通的C#类，在类中定义一个方法。如下：</p>
<pre>using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SqlServer.Server;
namespace SqlServerProject1
{

   public  class demo
    {
       [Microsoft.SqlServer.Server.SqlProcedure]
       public static void ClrProc() {
           SqlContext.Pipe.Send("Hello World");
       }
    }
}
</pre>
<p>记得要引入using Microsoft.SqlServer.Server这个命名空间。在方法体中，使用了如下代码
<pre>SqlContext.Pipe.Send("Hello World");</pre>
<p>可以理解为像客户端发送一条结果，就像Response.Write输出一样。<br />
<br />给这个普通的方法，加上[Microsoft.SqlServer.Server.SqlProcedure]特性。其意义就是标记自己是个CLR<br />
 存储过程。</p>
<p>注：Attribute，有的人也称作属性，为了避免不和面向对象中的get/set混淆，故本人习惯称之为”特性“。和java中的注解差不多。</p>
<p>编译通过后，可以选择直接在VS的生成菜单下选择”部署“，也可以去数据库中手动创建。</p>
<p>打开指定数据库的查询窗口，开始写脚本，检查数据库配置，看看是否开启了clr支持，没有的话则手动去开启：</p>
<pre>--查看系统配置
SELECT * FROM sys.configurations
ORDER BY name
GO
--启用clr
sp_configure 'clr enabled',1
go
RECONFIGURE;
GO</pre>
<p>准备完毕后，开始创建程序集和CLR存储过程：</p>
<pre>--创建程序集
CREATE ASSEMBLY SqlServerProject1
FROM
N'C:\Users\Administrator\Documents\visual studio 2010\Projects\Database1\SqlServerProject1\bin\Debug\SqlServerProject1.DLL'
WITH permission_set=SAFE
GO

--
--DROP ASSEMBLY SqlServerProject1
--go
--创建CLR存储过程 (程序集.命名空间.类型.方法名)
CREATE PROC dbo.helloworld
AS EXTERNAL NAME SqlServerProject1.[SqlServerProject1.demo].ClrProc
go

--执行Clr存储过程

EXEC helloworld
go</pre>
<p>注意，之前的项目中编译后的DLL文件的路径（推荐使用绝对路径），权限直接给safe。创建CLR存储过程，其实和普通的proc差不多，只不过多了一句（大致意思就是指定程序集中指定的命名空间下的类和对应的方法）<br />
<br />可以像调用普通的存储过程一样去执行它。看看结果，果然有了”HelloWorld“。呵呵。当然，这只是最简单的，目的是教大家如何创建。</p>
<p>当然，也可以创建复杂一点的存储过程/函数/触发器等。我就拿存储过程为例，做一个稍微复杂的，返回一个SqlDataReader对象。</p>
<p>直接在项目上右键，新建，选择存储过程即可（刚才新建一个普通类，是为了让大家理解其基本的实现和对应关系）。如图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDEyMDMvMTkvMF8xMzMyMTQzMTQyRE5xVi5naWY=.jpg"></p>
<p>建好存储过程后，可以往方法里面添加一些简单的代码，执行一个基本的单表查询，然后返回给客户端一个SqlDataReader对象。代码如下：</p>
<pre>using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void StoredProcedure1()
    {
        // 在此处放置代码
        SqlConnection conn = new SqlConnection("context connection=true");
        try
        {
            conn.Open();
            SqlCommand cmd = new SqlCommand("SELECT count(*) FROM dbo.TempCatalog", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            SqlContext.Pipe.Send(dr);
        }
        catch (Exception)
        {

            conn.Close();
        }
    }
};
</pre>
<p>编译完成后，可以在VS的生成菜单下选择”部署“（会自动部署到sqlserver中，并覆盖原来的）。当然，也可以手动去重新加载程序集并创建需要的存储过程。<br />
<br />在sqlserver中创建好并执行存储过程后，检查一下结果，看是不是你想要的？</p>
<p>提示：手动重复加载、创建，可能会冲突。需要先删除后再重新创建。可以在sqlserver对象浏览器中检查，也可以使用如下sql语句查询相关信息。</p>
<pre>SELECT * FROM sys.assemblies
SELECT * FROM sys.assembly_files</pre>
<p>简单的例子做完了，优点是可想而知的。那到底啥时候应用CLR，啥时候写T-sql呢？我觉得具体要根据实际业务需求和应用场景去判断了。<br />
<br />根据有些微软方面的专家提示，在下面几种情况下，应该考虑使用CLR： <br />SQL中涉及大量的逻辑判断和逻辑运算。比如需要在数据库级别自定义加密算法，解密算法等。 <br />T-SQL无法处理需求。比如需要在SQL中进行正则表达式的判断等。 <br />逻辑判断或者循环分支过于复杂，有时需要使用大量游标进行处理（也不一定使用游标就会变慢，关键看敲代码的人）。</p>
<p>本文出自<a href="http://blog.csdn.net/dinglang_2009" rel="external nofollow noreferrer">http://blog.csdn.net/dinglang_2009</a>，转载请注明出处。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 19:06:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8%e8%bf%87%e7%a8%8b/" title="存储过程">存储过程</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1/" title="面向对象">面向对象</a>, <a href="https://www.iamivan.net/tag/sqlserver/" title="Sqlserver">Sqlserver</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>初探SQL Server CLR 集成的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M12Rmxp.html" rel="bookmark">引用&colon;初探Sql Server 执行计划及Sql查询优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:引用:初探Sql Server 执行计划及Sql查询优化 初探Sql Server 执行计划及Sql查询优化 收藏 MSSQL优化之----探索MSSQL执行计划   作者:no_mIss   最近总想整理下对MSSQL的一些理解与感悟,却一直没有心思和时间写,晚上无事便写了一篇探索MSSQL执行计划,本文讲执行计划但不仅限于讲执行计划.   网上的SQL优化的文章实在是很多,说实在的,我也曾经到处找这样的文章,什么不要使用IN了,什么OR了,什么AND了,很多很多,还有很多人拿出仅几S甚			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6mEgz.html" rel="bookmark">Sql server CLR自定义类型存储对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问:我可以在SQL Server 2005中用CLR用户自定义类型来存储我的业务对象吗? 答:实现SQL CLR用户自定义类型(UDT)非常简单,就像给.NET类或者结构添加一些额外的片断.其中就包括属性(SqlUserDefinedTypeAttribute),和接口(INullable),以及一些额外的方法(Null() and Parse()).这个简单性带来的后果就是,一个有经验的开发人员可以在不到5分钟的时间里把一个业务对象转换为SQL CLR 用户自定义类型. SQL Server			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAa1G3M.html" rel="bookmark">SQL SERVER 2008 集成安装的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  最近需要测试一个项目, 需要SQL SERVER 2008, 在微软下载评估版后进行安装 中间发现了种种安装失败的问题,对该过程进行了记录,希望给遇到此类问题的朋友们共同探讨,有所帮助: 1. WINDOWS 2003, WINDOWS 7 新装的时候可行,但是如果有删除后重新安装则无法再次安装 2. 根据网上无数先驱的失败提示, 进行了无数重试,包括更改安装文件目录,修改注册表权限等均不能解决 3. 测试制作集成SP1和HOTFIX 首先下载有关补丁 下载SQLServer2008SP1-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1Mvj9VM.html" rel="bookmark">初探 SQL Server 2008 &OpenCurlyDoubleQuote;Katmai&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				微软下一代商业智能平台SQL Server 2008数据库,代号为:&quot;Katmai &quot;,而且公布了一些远景和目標. SQL Server 2008希望以更安全.更具延展性.更高的管理能力,而成為一个全方位企业资料.数据管理平台.其功能说明如下: 1.保护数据库咨询 SQL Server 2008本身将提供对整个数据库.数据表与Log加密的机制,并且程式存取加密数据库时,完全不需要修改任何程序. 2. 花费更少的时间在服务器的管理操作 SQL Server 2008将会采用一种Polic			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91A44M.html" rel="bookmark">CLR SQL SERVER：让正则表达式也加入你的Transaction-SQL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				试过Transaction-Sql编程的哥们应该都觉的这东西太恶心了,除了IDE,最恶心得还数编程中涉及的字符 串拼接问题.想象一下:在一个巨复杂的业务逻辑中,里面充满了while,if,case.你必须处理好所有的情 况并按某一规则来拼接字符串.这些字符串可能是Sql,也可能是结果,但不管是什么都是我们的噩梦. 正则表达式是啥相信就不要我介绍了,处理文本的利器呀.虽然Sql Server也支持正则表达式,但使 用比较麻烦,还是自己制作一个正则表达函数来的方便.这节主要涉及了CLR Sql Se			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXxlRLp.html" rel="bookmark">SQL Server与IIS7的集成验证配置方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 IIS7 中,配置 SQL Server 的集成验证步骤比较多,下面将配置的步骤列出,以方便学习. 首先,需要确认网站所使用的应用程序池.打开网站的基本设置对话框.检查应用程序池的配置参数. 然后,在应用程序池中,找到对应的应用程序池,并选择高级配置. 在标识中,选择网络服务 NewworkService. 现在,回到 SQL Server,在 安全性,登录名中,增加一个新的登录. 点击搜索,将会弹出选择用户或组的对话框. 点击左下角的高级按钮. 直接点击立即查找. 在列出的用户中找到 Ne			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq0ryz.html" rel="bookmark">如何通过SQL Server执行系统命令？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是如何通过SQL Server执行系统命令?, 0x00 简介 渗透测试过程中,大家经常会碰到通过MSSQL来进行提权或执行系统命令之类的操作,通常我们经常会使用xp_cmdshell来进行执行系统命令,但是当xp_cmdshell不能使用的时候,我们还有什么别的方式么?本文将介绍与分享一下我自己学到的一些姿势. 0x01 常用的一些姿势 1. XP_CMDSHELL 这个大家都比较熟悉了,通过xp_cmdshell来执行命令,可使用以下语句来执行: exec master..xp_cm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/dzZk6ab.html" rel="bookmark">&lbrack;收藏&rsqb;利用SQL Server Reporting Services 从应用程序生成用户友好的报表</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|services|程序 利用 SQL Server Reporting Services 从应用程序生成用户友好的报表 发布日期: 09/03/2004 | 更新日期: 09/03/2004John C. Hancock   http://www.microsoft.com/china/msdn/library/data/sqlserver/SQLServerReportServ.mspx本文讨论:•Reporting•设计和部署报表•使用 Reporting Services 的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbEeaLb.html" rel="bookmark">在 SQL Server 2005 中使用表值函数来实现空间数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				server|函数|数据|数据库 Gyorgy Fekete 和 Alex Szalay约翰霍普金丝大学 Jim GrayMicrosoft(联系作者) 适用于Microsoft SQL Server 2005 摘要:本文说明了如何使用 C# 和表值函数将空间搜索函数(&quot;邻近点的点&quot;和&quot;多边形内的点&quot;)添加到 Microsoft SQL Server 2005.使用此库可以在不编写任何特殊代码的情况下向应用程序中添加空间搜索.此库实现了来自约翰霍普金丝大学的公共域			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3PBNM.html" rel="bookmark" class="title">Dreamweaver制作基于WordPress的留言本III</a>
					<div>
						虽然说在Dreamweaver量身打造Wordpress留言板(二)这一篇当中,让留言板后台的帐号与Wordpress帐号共用,但登入的部分,还是得个别登入,这样感觉还是有些小麻烦,于是梅干突然想到, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkoyrp.html" rel="bookmark" class="title">从5个方面来探讨商城类网站的SEO效果</a>
					<div>
						随着互联网的发展,商城类网站越来越多的出现在我们的视野中,这些商场类网站既包括B2C商城,也包括大家做的大型淘宝客网站,这些网站由于自己的特点,所以在优化的时候也有一些技巧和注意的事项,今天我和大家分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdeA2z.html" rel="bookmark" class="title">NetMeeting在办公网络中的应用</a>
					<div>
						微软在Windows 2000 Server中集成了Microsoft NetMeeting 3.01,它允许用户在Internet/Intranet上进行实时的视频.音频和数据通信.它为公司内部.公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7jrmM.html" rel="bookmark" class="title">OLTP和DSS不同数据库设计</a>
					<div>
						OLTP 数据库 DSS 数据库 OLTP = online transaction processing DSS = data warehousing 联机事物处理 数据仓库 例如:飞机订票,网上交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ee4Ob.html" rel="bookmark" class="title">哪里可以下载到windows7 iso镜像32位系统</a>
					<div>
						  1.雨林木风YLMF ghost win7 32位装机正式版 用户评价:首次进入系统即全部硬件已安装完毕,通过数台不同硬件型号计算机测试安装均无蓝屏现象,硬件完美驱动.我的电脑右键添加&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK4aJM.html" rel="bookmark" class="title">eSATA是什么</a>
					<div>
						  eSATA的全称是External Serial ATA(外部串行ATA),它是SATA接口的外部扩展规范.换言之,eSATA就是&quot;外置&quot;版的SATA,它是用来连接外部而非内部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaQOkz.html" rel="bookmark" class="title">win7 32位系统下摄像头黑屏无法使用如何修复</a>
					<div>
						  1.首先鼠标右击win7系统下桌面上的&quot;计算机&quot;图标,然后选择&quot;管理&quot;; 2.在打开的计算机管理界面汇总,点击&quot;设备管理器--&gt;图像设备&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWA6Pb.html" rel="bookmark" class="title">GHOST删除分区和修复硬盘坏扇区</a>
					<div>
						  相信GHOST这款软件一定是每一位DIYer必备的工具软件.但是如果你只是用GHOST来备份和还原数据的话,那你可委屈了这款&quot;功能强大&quot;的软件了.其实GHOST还有一些比较另类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBwLYz.html" rel="bookmark" class="title">Eclipse创建的JSP文件链接SQLServer2012的方法（附图）</a>
					<div>
						  一直喜欢用eclipse做java相关的东西,jsp同样也不例外,网上教程把明明很简单的东西写的乱七八糟的,还是我自己来点儿硬货吧! 你需要下载的东西只有一个: Microsoft SQL Ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwxWBp.html" rel="bookmark" class="title">《私有云计算整合、虚拟化和面向服务的基础设施》一2&period;5Layer-2演化</a>
					<div>
						2.5Layer-2演化 深入研究光纤模块之前,让我们想一下目前的优化技术已经克服了以往哪些DC技术缺陷,而当前DC技术还存在哪些可被优化的地方,显然后者比前者更重要,因为它将带来更好的技术效率和改善 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXw2Q4M.html" rel="bookmark" class="title">SOA面向服务架构的概念及应用</a>
					<div>
						什么是SOA SOA(Service-Oriented Architecture),即面向服务的架构.SOA是一种粗粒度.松耦合服务架构,服务之间通过简单.精确定义接口进行通讯,不涉及底层编程接口和通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPg5vp.html" rel="bookmark" class="title">Attic - 拥有重复数据删除技术的备份软件</a>
					<div>
						&lt;iframe style=&quot;width: 170px; height: 30px;&quot; src=&quot;http://ghbtns.com/github-btn.html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR8JXz.html" rel="bookmark" class="title">IE7同时下载多个文件失败怎么办&comma;IE7同时下载多个文件失败原因分析</a>
					<div>
						解决方案: 提示:修改注册表有风险,请提前备份重要数据.   1.打开记事本,新建一个 txt 文档.   2.将以下内容复制粘贴到 txt 文档中:   Windows Registry Edito ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq27xb.html" rel="bookmark" class="title">【Android】Android中WIFI开发总结（二）</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://smallwoniu.blog.51cto.com/3911954/1338618 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32vlwz.html" rel="bookmark" class="title">&period;net-System&period;UnauthorizedAccessException&colon; 对路径&OpenCurlyDoubleQuote;vssver2&period;scc&rdquo;的访问被拒绝。</a>
					<div>
						问题描述 System.UnauthorizedAccessException: 对路径&quot;vssver2.scc&quot;的访问被拒绝. ASP.NET 未被授权访问所请求的资源.请考虑授 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB1XrM.html" rel="bookmark" class="title">2017年中国物联网高峰论坛在深圳成功举行</a>
					<div>
						物联网是继工业和信息化革命后的又一场伟大的革命,带来了全球第三次信息化浪潮,它将引领人类社会进入一个崭新的智能智慧时代.成为推动世界经济增长.人类社会进步的新的&quot;驱动器&quot;和&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40RA8z.html" rel="bookmark" class="title">聚合大数据分析和应用玩家 他们搞啥？</a>
					<div>
						文章讲的是聚合大数据分析和应用玩家 他们搞啥,近年来,大数据正日益成为国家基础性战略资源,蕴藏着巨大的潜力和能量.在国家层面,发展大数据已成为提升竞争力的战略选择;在经济层面,发展大数据已成为打造新动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRK63b.html" rel="bookmark" class="title">jquery 给html指定标签增加元素</a>
					<div>
						jquery 给html指定标签增加元素 wrap html (string) : html标记代码字符串,用于动态生成元素并包裹目标元素 示例 把所有的段落用一个新创建的div包裹起来 html 代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBeloM.html" rel="bookmark" class="title">微软能采取苹果的经营模式吗？</a>
					<div>
						微软公司首席执行官(CEO)史蒂夫·鲍尔默(Steve Ballmer)想必非常钦佩苹果公司.这就可以说明他为什么想让微软采用苹果经营模式的原因. 鲍尔默在致股东.客户.员工及合作伙伴的年度公开信中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RGW6z.html" rel="bookmark" class="title">邵敬江&colon;写给想用服务器的朋友</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 相信许多成功的站长都有自己的服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7NvWM.html" rel="bookmark" class="title">机会和隐忧：人类最大的生物识别数据库正在印度实施</a>
					<div>
						印度实施的唯一身份识别(Unique Identification)项目(也被称作 Aadhar 计划),本周早些时候完成了人口统计和生物识别数据的收集,总量超过 5 亿印度居民--是目前全球同类生物 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLAamp.html" rel="bookmark" class="title">亚信安全童宁：机器学习驱动网络安全发展</a>
					<div>
						随着人工智能.机器学习.态势感知.移动虚拟化.物联网安全.大数据.高级威胁调查取证等新兴技术在网络威胁治理方面的深度融合,网络安全产业迎来了新一轮变革,也成为2017年国家网络安全宣传周关注的焦点.9 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWooZz.html" rel="bookmark" class="title">javascript之IE版本检测超简单方法&lowbar;javascript技巧</a>
					<div>
						近年来随着操作系统的升级以及各种新技术的开发普及,抛弃低版本IE已经是大势所趋,这对于前端人员来时是个好消息,可以不用花费太多的时间来做低版本的兼容,很多站点采用给予低版本IE以提示的方式(恩,很友好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0wvVp.html" rel="bookmark" class="title">怎么使用java代码查看我设置的jvm参数&quest;</a>
					<div>
						问题描述 如题我设置了一些 jvm参数我想在页面上显示出来我设置的结果怎么使用java代码 获取设置的jvm参数 解决方案 ManagementFactory.getRuntimeMXBean().g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm14Pb.html" rel="bookmark" class="title">web 服务器问题</a>
					<div>
						问题描述 为什么我的web服务器时而可以访问,时而不能访问,网速没问题,即使不用网关,在同一个局域网内也非常的卡! 解决方案 解决方案二:该回复于2012-04-18 10:05:27被版主删除解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqqyjp.html" rel="bookmark" class="title">隔行如隔山，顺丰&OpenCurlyDoubleQuote;嘿客&rdquo;有点难</a>
					<div>
						在中国有句古话叫做:隔行如隔山!你以为你能做好一个厨子,你就能做一个好裁缝啊?嘿嘿,不想当裁缝的厨子,那就不是好司机!而下面就是我今天下午亲自来到杭州最大的一家&quot;顺丰嘿店&quot;和一家标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXv16z.html" rel="bookmark" class="title">ORA-00932&colon; Hibernate 映射和查询</a>
					<div>
						问题描述 &lt;li&gt;ORA-00932:???????:??NUMBER,????BINARY&lt;/li&gt;&lt;li&gt;couldnotloadanentity:[com.t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOW64qz.html" rel="bookmark" class="title">根除互联网不良信息是目标还是动机？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最近有关部门对于互联网不良信息整治 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4N1Ab.html" rel="bookmark" class="title">如何有效处理数据中心产生的海量日志</a>
					<div>
						数据中心里包含有成千上万的电子设备,这些设备连接到一起就可以灵活部署很多应用业务.然而,这么多设备同时在线运行,不出一点问题是根本做不到的,就是技术最牛的互联网大佬的数据中心也是时不时爆出各种故障.实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK3Xynb.html" rel="bookmark" class="title">热门关键词搜索结果多样性</a>
					<div>
						什么是搜索结果多样性?当我们搜索一个热门关键词时,搜索引擎会尽可能返回不同类别的结果给我们,比如我们http://www.aliyun.com/zixun/aggregation/8601.html& ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
